package xyz.ottr.lutra.revottr;

/*-
 * #%L
 * xyz.ottr.lutra:lutra-revottr
 * %%
 * Copyright (C) 2018 - 2023 University of Oslo
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-2.1.html>.
 * #L%
 */

import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Collections;
import java.util.Set;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.shared.PrefixMapping;
import xyz.ottr.lutra.api.StandardFormat;
import xyz.ottr.lutra.api.StandardTemplateManager;
import xyz.ottr.lutra.revottr.evaluation.Evaluator;
import xyz.ottr.lutra.revottr.model.Mapping;
import xyz.ottr.lutra.revottr.model.terms.Placeholder;

public class Example {

    public static void main(String[] args) {
        Path root = Paths
                .get("lutra-revottr","src", "main", "resources")
                .toAbsolutePath();

        String libPath = root.resolve("exampleLib.stottr").toString();

        // Read template library into template manager, load standard template lib
        StandardTemplateManager templateManager = new StandardTemplateManager();
        templateManager.readLibrary(StandardFormat.stottr.name(), Collections.singleton(libPath));
        templateManager.loadStandardTemplateLibrary();

        // Add standard library templates
        templateManager.getStandardLibrary().getAllTemplates()
                .innerForEach(templateManager.getTemplateStore()::addTemplate);


        String graphPath = root.resolve("exampleGraph.ttl").toString();

        // Read graph into Jena model
        Model model = ModelFactory.createDefaultModel().read(graphPath);

        // Create evaluator from model and template manager.
        // Maximum repetitions in lists generated by reverse list expansion is set to 0
        Evaluator evaluator = new Evaluator(model, templateManager, 0);

        // Specify IRI of template to be used as query
        String queryIRI = "http://example.org/example/Person";

        // Query the selected template over the graph in the model of the evaluator.
        // The result is a set of mappings that represent instances of the selected template
        Set<Mapping> mappings = evaluator.evaluateQuery(queryIRI);

        // Create prefix for the special "placeholder" terms that occur in the output
        PrefixMapping prefixMapping = templateManager.getPrefixes();
        prefixMapping.setNsPrefix("ph", Placeholder.namespace);

        // Print each mapping in the output on a new line, with prefixes.
        // Commented out because code checker complains about System.out.println
        mappings.forEach(m -> System.out.println(m.toString(prefixMapping)));

        // Translate and print mappings as instances of the template with IRI queryIRI.
        // Again commented out to comply with code checker
        Converter.toInstances(
                mappings,
                templateManager.getTemplateStore().getSignature(queryIRI).get()
        ).forEach(i -> System.out.println(i.toString(prefixMapping)));
    }
}
